unit OpenPcxDlg;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Menus, FileCtrl;

type
  TfrmOpenPCX = class(TForm)
    Panel1: TPanel;
    OpenDlg: TOpenDialog;
    pnlMain: TPanel;
    DirectoryBox: TDirectoryListBox;
    Filebox: TFileListBox;
    DriveBox: TDriveComboBox;
    pnlimage: TPanel;
    imgPreview: TImage;
    Panel3: TPanel;
    Image2: TImage;
    Label1: TLabel;
    Panel4: TPanel;
    Image3: TImage;
    Label2: TLabel;
    Image4: TImage;
    FileSize: TLabel;
    btnAccept: TButton;
    BtnCancel: TButton;
    btnAcceptClose: TButton;
    procedure FileboxClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure btnAcceptClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnAcceptCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    PCXFileName : string;
    Files       : TStrings;
    { Public declarations }
  end;

var
  frmOpenPCX: TfrmOpenPCX;
  FileName : string;

implementation

{$R *.DFM}
uses PcxCtrl;

procedure TfrmOpenPCX.FileboxClick(Sender: TObject);
var
  Bitmap    : TPCXBitmap;
  H, W, Tmp : Integer;
begin
  FileName:=Directorybox.directory;
  //check to see if a Slash is needed at end of Directory name
  If not IsPathDelimiter(FileName, Length(FileName)) then FileName:=FileName+'\';
  FileName:=FileName+Filebox.Items[filebox.itemindex];

  Bitmap := TPCXBitmap.Create;
  imgPreview.Stretch:=False;
  imgPreview.Width:=256; imgPreview.Height:=256;
  //  Try and open the file
  try
    Bitmap.LoadFromFile(Filename);
    w:=Bitmap.Width; h:=Bitmap.Height;
    // Display image dimensions
    FileSize.Caption:='Size: '+IntToStr(W)+'x'+IntToStr(H);
    // If height or width > 256 then Scale to fit
    If (h > w) then tmp:=h else tmp:=w;
    If Tmp > 256 then
    Begin
      While tmp > 256 do
      Begin
        w:=(w Div 2); h:=(h div 2);
        tmp:=(Tmp Div 2);
      End;
      // Define new Image preview dimensions;
      imgPreview.Width:=w; imgPreview.Height:=h; ImgPreview.Stretch:=True;
      FileSize.Caption:=FileSize.Caption+' (Scaled to fit)';
    End;
    // diaply the Picture
    ImgPreview.Picture.Assign(Bitmap);
  except
     MessageDlg('Invalid PCX file format.' + #13 + 'Probably 24 bit or higher image.', mtError, [mbOk], 0);
  end;

  Bitmap.Free;

end;

procedure TfrmOpenPCX.BtnCancelClick(Sender: TObject);
begin
  Close;
end;

// JESCO !!
procedure TfrmOpenPCX.btnAcceptClick(Sender: TObject);
var
  i       : integer;
  Path    : string;
begin
  Path := Directorybox.directory;
  //check to see if a Slash is needed at end of Directory name
  If not IsPathDelimiter(Path, Length(Path)) then Path := Path + '\';
  //add selected files to list
  if ( FileBox.SelCount <> 0 ) then
    for i:=0 to FileBox.Items.Count-1 do
      if ( FileBox.Selected[i] = TRUE ) then
        Files.Add(Path + FileBox.Items.Strings[i]);

//  Close;
end;

// JESCO !!
procedure TfrmOpenPCX.FormShow(Sender: TObject);
begin
  // Init stuff here !
  Files.Free;
  Files := TStringList.Create;
end;

procedure TfrmOpenPCX.btnAcceptCloseClick(Sender: TObject);
var
  i       : integer;
  Path    : string;
begin
  Path := Directorybox.directory;
  //check to see if a Slash is needed at end of Directory name
  If not IsPathDelimiter(Path, Length(Path)) then Path := Path + '\';
  //add selected files to list
  if ( FileBox.SelCount <> 0 ) then
    for i:=0 to FileBox.Items.Count-1 do
      if ( FileBox.Selected[i] = TRUE ) then
        Files.Add(Path + FileBox.Items.Strings[i]);

  Close;
end;

end.
